import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;

public class Main {
  public static void main(String[] args) throws Exception {
    Connection conn = null;
    Statement stmt = null;
    ResultSet rs = null;

    conn = getOracleConnection();
    stmt = conn.createStatement();
    rs = stmt.executeQuery("SELECT emp, age FROM employee");

    while (rs.next()) {
      oracle.sql.STRUCT emp = (oracle.sql.STRUCT) rs.getObject(1);
      Object[] empValues = emp.getAttributes();
      String name = (String) empValues[0];
      java.math.BigDecimal badgeNumber = (java.math.BigDecimal) empValues[1];
      int age = rs.getInt(2);
      System.out.println("name=" + name);
      System.out.println("badgeNumber=" + badgeNumber);
      System.out.println("age=" + age);
    }
    rs.close();
    stmt.close();
    conn.close();
  }

  private static Connection getHSQLConnection() throws Exception {
    Class.forName("org.hsqldb.jdbcDriver");
    System.out.println("Driver Loaded.");
    String url = "jdbc:hsqldb:data/tutorial";
    return DriverManager.getConnection(url, "sa", "");
  }

  public static Connection getMySqlConnection() throws Exception {
    String driver = "org.gjt.mm.mysql.Driver";
    String url = "jdbc:mysql://localhost/demo2s";
    String username = "oost";
    String password = "oost";

    Class.forName(driver);
    Connection conn = DriverManager.getConnection(url, username, password);
    return conn;
  }

  public static Connection getOracleConnection() throws Exception {
    String driver = "oracle.jdbc.driver.OracleDriver";
    String url = "jdbc:oracle:thin:@localhost:1521:databaseName";
    String username = "userName";
    String password = "password";

    Class.forName(driver); // load Oracle driver
    Connection conn = DriverManager.getConnection(url, username, password);
    return conn;
  }

}
